;===========================================================================
;
;    B O I L E R  -  Boilerplate external assembly language source file
;
;===========================================================================
;
;    by Jeff Duntemann      12 February 1988
;
;     From: COMPLETE TURBO PASCAL 5.0  by Jeff Duntemann
;    Scott, Foresman & Co., Inc. 1988   ISBN 0-673-38355-5
;
; BOILER is written to be called from Turbo Pascal V4.0 using the
; {$L}/EXTERNAL procedure convention.
;
; Declare the procedure itself as external using this declaration:
;
; {$L BOILER }
; PROCEDURE Boiler; EXTERNAL;
;
; To reassemble/relink BOILER:
;-------------------------------------
; Assemble this file with MASM or TASM; i.e.  "C>TASM BOILER;"
;

CODE    SEGMENT BYTE PUBLIC
        ASSUME  CS:CODE
        PUBLIC  BOILER

BOILER  PROC    NEAR
        PUSH    BP                      ;SAVE PREVIOUS VALUE OF BP ON STACK
        MOV     BP,SP                   ;SP BECOMES NEW VALUE OF BP


        ; THE BODY OF YOUR EVENTUAL PROC GOES HERE...


        MOV     SP,BP                   ; RESTORE PRIOR STACK POINTER & BP
        POP     BP                      ;  IN CONVENTIONAL RETURN
        RET

BOILER  ENDP
CODE    ENDS
        END
