;---------------------------------------------------------------------------
;- NO_MD_RD.ASM    By Rafe Aldridge. Copyright (C) 1993 by Rafe Aldridge   -
;---------------------------------------------------------------------------
;- ??? : A TSR (terminate and stay resident) program that disables the     -
;-       create and remove subdirectory DOS functions. Any attempt by DOS  -
;-       or an application program to create or remove a subdirectory will -
;-       be suppressed and replaced by a beep.                             -
;---------------------------------------------------------------------------
;
; Ŀ
;  Rafe's TP Collection is SHAREWARE                             
; Ĵ
;                                                                
;  If you find any part of Rafe's TP Collection usefull then     
;  please become a registered user by sending 10 Pounds Sterling 
;  to the address below. In return you will recieve the LATEST   
;  FULL source code to ALL the units as well anything new.       
;                                                                
;  Please feel free to write with suggestions, ideas or money to 
;      Rafe Aldridge,                                            
;      Street Farm,                                              
;      Dereham Road,                                             
;      Garvestone,                                               
;      Norfolk.                                                  
;      NR9 4QT                                                   
;      ENGLAND                                                   
;                                                                
; 
;
;- Compile : Using TASM ver 3.2 and TLINK 5.1                              -
;-           Type TASM NO_MD_RD [return]                                   -
;-                TLINK /t NO_MD_RD [return]                               -
;-           Will also compile with A86                                    -
;-           Should compile using MASM, LINK and EXE2BIN                   -
;---------------------------------------------------------------------------
;- Usage : Simply type NO_MD_RD at the DOS prompt. NOTE: this program does -
;-         not check to see if it already exists in memory and WILL        -
;-         install twice.                                                  -
;---------------------------------------------------------------------------

; set up assembler

  .8086
  .radix 16
    page ,80
  code segment para public 'code'
  assume cs:code,ds:code,es:code,ss:code
  org 100

; start of resident portion of TSR

start:
  jmp install

; jump to old DOS ISR

old_dos:       db 0eah ; jump instruction
old_dos_off    dw 0    ; address will be stored here
old_dos_seg    dw 0

new_dos:

; check function to see if it is an MD or RD function

  cmp ah,39h ; check to see if it is MD
  je beep    ; it's MD so redefine function to be a beep

  cmp ah,3ah   ; check to see if it is RD
  jne dos_exit ; it's not RD or MD so don't touch

beep:
  mov ah,02 ; replace function with function to beep
  mov dl,07

dos_exit:
  jmp old_dos ; call the old dos routine

tsr_end         db 0 ; marks the end of the TSR resident portion

; TSR Transient portion

install:

; get old ISR address for interrupt 21h

  mov ax,3521h
  int 21h
  mov cs:[old_dos_off],bx ; store ISR address in jump statement
  mov cs:[old_dos_seg],es

; install new DOS ISR

  xor ax,ax ; zero ES register
  mov es,ax
  mov dx,offset new_dos ; point to start of program

  cli
  mov word ptr es:[84],dx ; update vector offset
  mov word ptr es:[86],cs ; update vector segment
  sti

; free memory used by environment block

  mov ah,62h ; get address of PSP
  int 21h

  mov es,bx ; get address of environment block from PSP
  mov bx,word ptr es:[2ch]

  mov es,bx ; free environment block
  mov ah,49h
  int 21h

; display message

  push cs ; point ds at code segment
  pop ds
  mov dx,offset message ; point to message
  mov ah,9
  int 21h ; display message

; TSR !

  mov dx,offset tsr_end ; length of resident portion
  int 27h

message db 0ah,0dh,'NO_MD_RD.COM   Copyright (C) 1993 by Rafe Aldridge.',0ah,0dh,'The DOS functions to make and remove directories have been disabled.',0ah,0dh,24h

code ends
  end start
