#
# MAKE FILE FOR SKYHAWK DEVELOPMENT KIT
#
# ---------------------------------------- Force evaluation of dependencies

skyhawk.sys:    shclrdef.tpu    sherrmsg.tpu    shcmplx.tpu     \
                shcrcchk.tpu                                    \
                shutilpk.tpu    shdatpk.tpu     shfinanc.tpu    \
                shlist.tpu      shlngstr.tpu                    \
                shcmdlin.tpu    overshdk.tpu    overcmdl.tpu    \
                overlstr.tpu                                    \
                                                                \
                testbetw.tpu    testcmpx.tpu    testcolr.tpu    \
                testcrc.tpu     testdate.tpu    testfin.tpu     \
                testlist.tpu    testutil.tpu                    \
                                                                \
                execswap.tpu    testdrvr.tpu                    \
                                                                \
                testshdk.exe    testcmdl.exe    testerr.exe     \
                testlstr.exe

# ---------------------------------------  Implicit rules

# Change the string 't:\tp6\tpc' to the path to your Turbo Pascal compiler
#       file in the next two commands.

.pas.exe:
  t:\tp6\tpc /m $*

.pas.tpu:
  t:\tp6\tpc /m $*

# Change the string 't:\tp55\tasm' to the path to your Turbo assembler
#       file in the next command.

.asm.obj:
  t:\tp55\tasm $*

# ---------------------------------------  Object files

execswap.obj:   execswap.asm

# ---------------------------------------  Unit files

execswap.tpu:   execswap.pas    execswap.obj

overshdk.tpu:   overshdk.pas

overcmdl.tpu:   overcmdl.pas

overlstr.tpu:   overlstr.pas

shclrdef.tpu:   shdefine.inc    shunitsw.inc    shclrdef.pas

shcmplx.tpu:    shdefine.inc    shunitsw.inc    shcmplx.pas

shcrcchk.tpu:   shdefine.inc    shunitsw.inc    shcrcchk.pas

shdatpk.tpu:    shdefine.inc    shunitsw.inc    shdatpk.pas

sherrmsg.tpu:   shdefine.inc    shunitsw.inc    sherrmsg.pas

shfinanc.tpu:   shdefine.inc    shunitsw.inc    shutilpk.tpu    \
                sherrmsg.tpu    shfinanc.pas

shlist.tpu:     shdefine.inc    shunitsw.inc    shlist.pas

shlngstr.tpu:   shdefine.inc    shunitsw.inc    shlngstr.pas

shutilpk.tpu:   shdefine.inc    shunitsw.inc    shutilpk.pas

shcmdlin.tpu:   shdefine.inc    shunitsw.inc    shcmdlin.pas    \
                                shlist.tpu      shutilpk.tpu

testbetw.tpu:   shdefine.inc    shunitsw.inc    testbetw.pas    \
                                                shutilpk.tpu

testcmpx.tpu:   shdefine.inc    shunitsw.inc    testcmpx.pas    \
                                                shcmplx.tpu

testcolr.tpu:   shdefine.inc    shunitsw.inc    testcolr.pas    \
                                                shclrdef.tpu

testcrc.tpu:    shdefine.inc    shunitsw.inc    testcrc.pas     \
                                                shcrcchk.tpu

testdate.tpu:   shdefine.inc    shunitsw.inc    testdate.pas    \
                                                shdatpk.tpu

testdrvr.tpu:   shdefine.inc    testshdk.pas    execswap.tpu    \
                overshdk.tpu    testbetw.tpu    testfin.tpu     \
                testcmpx.tpu    testcolr.tpu    testcrc.tpu     \
                testdate.tpu    testlist.tpu    testutil.tpu    \
                                                                \
                testcmdl.exe    testerr.exe     testlstr.exe

testlist.tpu:   shdefine.inc    shunitsw.inc    testlist.pas    \
                                                shlist.tpu

testfin.tpu:    shdefine.inc    shunitsw.inc    shfinanc.tpu    \
                                sherrmsg.tpu    testfin.pas

testutil.tpu:   shdefine.inc    shunitsw.inc    testutil.pas    \
                                                shutilpk.tpu

# ---------------------------------------  Executable files

testcmdl.exe:   shdefine.inc    testcmdl.pas    shcmdlin.tpu    \
                overcmdl.tpu

testerr.exe:    shdefine.inc    testerr.pas     sherrmsg.tpu

testlstr.exe:   shdefine.inc    testlstr.pas    shcrcchk.tpu    \
                shutilpk.tpu    shlngstr.tpu    overlstr.tpu

testshdk.exe:   shdefine.inc    testshdk.pas    execswap.tpu    \
                overshdk.tpu    testbetw.tpu                    \
                testcmpx.tpu    testcolr.tpu    testcrc.tpu     \
                testdate.tpu    testlist.tpu    testutil.tpu    \
                testdrvr.tpu                                    \
                                                                \
                testcmdl.exe    testerr.exe     testlstr.exe
